/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.ripartizione.dbmodel.jooq.tables;


import com.alkemy.sophia.ripartizione.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.Indexes;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.Keys;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.tables.records.CurrencyRateRecord;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class CurrencyRate extends TableImpl<CurrencyRateRecord> {

    private static final long serialVersionUID = -229953975;

    /**
     * The reference instance of <code>currency_rate</code>
     */
    public static final CurrencyRate CURRENCY_RATE = new CurrencyRate();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<CurrencyRateRecord> getRecordType() {
        return CurrencyRateRecord.class;
    }

    /**
     * The column <code>currency_rate.year</code>.
     */
    public final TableField<CurrencyRateRecord, String> YEAR = createField("year", org.jooq.impl.SQLDataType.CHAR(4).nullable(false), this, "");

    /**
     * The column <code>currency_rate.month</code>.
     */
    public final TableField<CurrencyRateRecord, String> MONTH = createField("month", org.jooq.impl.SQLDataType.CHAR(2).nullable(false), this, "");

    /**
     * The column <code>currency_rate.src_currency</code>.
     */
    public final TableField<CurrencyRateRecord, String> SRC_CURRENCY = createField("src_currency", org.jooq.impl.SQLDataType.CHAR(3).nullable(false), this, "");

    /**
     * The column <code>currency_rate.dst_currency</code>.
     */
    public final TableField<CurrencyRateRecord, String> DST_CURRENCY = createField("dst_currency", org.jooq.impl.SQLDataType.CHAR(3).nullable(false), this, "");

    /**
     * The column <code>currency_rate.rate</code>.
     */
    public final TableField<CurrencyRateRecord, BigDecimal> RATE = createField("rate", org.jooq.impl.SQLDataType.DECIMAL(30, 20).nullable(false), this, "");

    /**
     * Create a <code>currency_rate</code> table reference
     */
    public CurrencyRate() {
        this(DSL.name("currency_rate"), null);
    }

    /**
     * Create an aliased <code>currency_rate</code> table reference
     */
    public CurrencyRate(String alias) {
        this(DSL.name(alias), CURRENCY_RATE);
    }

    /**
     * Create an aliased <code>currency_rate</code> table reference
     */
    public CurrencyRate(Name alias) {
        this(alias, CURRENCY_RATE);
    }

    private CurrencyRate(Name alias, Table<CurrencyRateRecord> aliased) {
        this(alias, aliased, null);
    }

    private CurrencyRate(Name alias, Table<CurrencyRateRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> CurrencyRate(Table<O> child, ForeignKey<O, CurrencyRateRecord> key) {
        super(child, key, CURRENCY_RATE);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.CURRENCY_RATE_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<CurrencyRateRecord> getPrimaryKey() {
        return Keys.KEY_CURRENCY_RATE_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<CurrencyRateRecord>> getKeys() {
        return Arrays.<UniqueKey<CurrencyRateRecord>>asList(Keys.KEY_CURRENCY_RATE_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public CurrencyRate as(String alias) {
        return new CurrencyRate(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public CurrencyRate as(Name alias) {
        return new CurrencyRate(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public CurrencyRate rename(String name) {
        return new CurrencyRate(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public CurrencyRate rename(Name name) {
        return new CurrencyRate(name, null);
    }
}
